close all
clear all
clc

D=[0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1];


trem=[47
69.54
72.57
74.87
76.42
76.42
80.33
81.92
90.8
94.1
106.8
122.7
123.6
124.5
139.2
166.1
180.9
181.7
280.9
307.2
552.9
99.12
178.2
189.7
213.9
248.1
260.8
298.7
435.3
67.3
810.9
77.2
104.2
105.9
109.4
120
124.4
132.7
147.5
151.7
159.3
162.7
189.7
191.4
197.7
203.9
253.3
275.9
286
287.7
375.4
488.2]


Dil6=[0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1
1];


il6=[41.87
9.73
65.27
82
3.48
7.38
109
7.93
50.23
8.57
15.42
12.43
14.38
115.1
17.84
101.1
10.95
18.71
39.16
13.03
28.76
322.3
341.1
139
87.29
135.8
313.3
226.7
15.84
13.6
336.6
219.1
326.8
17.19
97.55
104.5
301.8
330.7
311.8
337.5
18.42
339.9
335.4
66.69
355
337.6
NaN
325.7
340.8
43.24
332.5
60.31];

%You can run the following code cell by cell:
%choose to activate only of of the following lines depending on the marker
%you want to focus on:
%y1=trem(D==0);y2=trem(D==1); %activate this is for sTREM
D(isnan(il6)==1)=[];il6(isnan(il6)==1)=[];y1=il6(D==0);y2=il6(D==1); %activate this is for IL6


%% ====plot the overlapping histograms==========
close all
subplot(1,2,1)
doublehist(y1,y2, 10)
xlabel('scores');ylabel('frequency')
subplot(1,2,2)
[X Y T AUC]=perfcurve(D,[y1;y2],1);
plot(X,Y)
xlabel('t=FPR');ylabel('ROC(t)=TPR')
AUC

%% ==========Plot the empirical ROC curve along with the associated maximized Youden index========
close all
clc
[Jhatemp, cutoffemp, ties, at, X, Y]=Jhatempirical([y1;y2],[D ]);
Jhatemp
cutoffemp

plot(X,Y)
hold on
plot(0:0.01:1,0:0.01:1,'k')
plot(X(at),Y(at),'*r')
plot(X(at),X(at),'*r')
plot([X(at) X(at)],[Y(at) X(at)],'r')

xlabel('t=FPR')
ylabel('ROC(t)=TPR')



%% PERFORM THE PROPOSED APPROACHES FOR DERIVING A 95% CI FOR THE MAXIMIZED YOUDEN INDEX:
clc
init=cutoffemp;


%[Jhat, CI, CIwidth, exitflag]=JCIs(y1,y2,'DeltaBC')
%[Jhat, CI, CIwidth, exitflag]=JCIs(y1,y2,'DeltaBCJT')
%[Jhat, CI, CIwidth, exitflag]=JCIs(y1,y2,'DeltaBClam')
%[Jhat, CI, CIwidth, exitflag]=JCIs(y1,y2,'DeltaBClamJT')
%[Jhat, CI, CIwidth, exitflag]=JCIs(y1,y2,'Shan')
%[Jhat, CI, CIwidth, exitflag]=JCIs(y1,y2,'Shancr')
[Jhat, CI, CIwidth, exitflag]=JCIs(y1,y2,'HCNS',init);
%[Jhat, CI, CIwidth, exitflag]=JCIs(y1,y2,'kernels',init);

%% PERFORM THE PROPOSED APPROACHES FOR DERIVING A 95% CI FOR THE YOUDEN BASED CUTOFF:
clc
%[chat, CI, CIwidth, exitflag]=cutoffCIs(y1,y2,'BC');
[chat, CI, CIwidth, exitflag]=cutoffCIs(y1,y2,'HCNS',init);
%[chat, CI, CIwidth, exitflag]=cutoffCIs(y1,y2,'kernels',init);










