 function out=COVlam(x,y)

%Accepts X<Y. Yields as an output the Variance Covariance matrix
%of the mh, sh, md, sd, and lam, (with this order) where lam is the estimated boxcox
%parameter. Thus, the output will be a 5x5 matrix.

%---FOR TWO POPULATIONS:

n=length(x);
m=length(y);

%mh-->g(1)
%sh-->g(2)
%md-->g(3)
%sd-->g(4)
%lam-->g(5)
%  logL=@(g) -n*log(sh)-1/(2*sh^2)*sum((xlam-mh).^2)+(lam-1)*sum(log(x)) -...
%             m*log(sd)-1/(2*sd^2)*sum((ylam-md).^2)+(lam-1)*sum(log(y))

 [transx transy lam]=boxcoxleo(x,y);
 mh=mean(transx); xlam=transx;  
 md=mean(transy); ylam=transy;  
 sh=sqrt(1./(length(transx))*sum((transx-mean(transx)).^2));
 sd=sqrt(1./(length(transy))*sum((transy-mean(transy)).^2));


  
 I(1,1)=n/sh^2;  
 I(2,2)=-(n/sh^2-3/sh^4*sum((xlam-mh).^2)); 
 I(3,3)=m/sd^2; 
 I(4,4)=-(m/sd^2-3/sd^4*sum((ylam-md).^2));
 
 kk=  sum(((mh - (x.^lam - 1)./lam).*((2.*(x.^lam - 1))./lam.^3 - (2.*x.^lam.*log(x))./lam.^2 + (x.^lam.*log(x).^2)./lam))./sh.^2) +...
      - sum(((y.^lam - 1)./lam.^2 - (y.^lam.*log(y))./lam).^2./sd.^2) +...
      - sum(((x.^lam - 1)./lam.^2 - (x.^lam.*log(x))./lam).^2./sh.^2) +...
      + sum(((md - (y.^lam - 1)./lam).*((2.*(y.^lam - 1))./lam.^3 - (2.*y.^lam.*log(y))./lam.^2 + (y.^lam.*log(y).^2)./lam))./sd.^2);
 I(5,5)=-kk ;

 I(1,5)=sum(((2.*(x.^lam - 1))./lam.^2 - (2.*x.^lam.*log(x))./lam)./(2.*sh.^2));
 I(2,5)=-sum((2.*((x.^lam - 1)./lam.^2 - (x.^lam.*log(x))./lam).*(mh - (x.^lam - 1)./lam))./sh^3);
 I(3,5)=-sum(-((2.*(y.^lam - 1))./lam.^2 - (2.*y.^lam.*log(y))./lam)./(2.*sd.^2));

 
 I(4,5)=-sum((2.*((y.^lam - 1)./lam.^2 - (y.^lam.*log(y))./lam).*(md - (y.^lam - 1)./lam))./sd.^3);
 
 I(5,1)=I(1,5);
 I(5,2)=I(2,5);
 I(5,3)=I(3,5);
 I(5,4)=I(4,5);


 S= I\eye(5,5); %that's better.

 out=S;
end
 

 

 
	