 

function out=COVnolam(x,y)

%Accepts X<Y. Yields as an output the Variance Covariance matrix
%of the mh, sh, md, sd, and lam, (with this order) where lam is the estimated boxcox
%parameter. Thus, the output will be a 5x5 matrix.

%---FOR TWO POPULATIONS:

n=length(x);
m=length(y);

%mh-->g(1)
%sh-->g(2)
%md-->g(3)
%sd-->g(4)
%lam-->g(5)
%  logL=@(g) -n*log(sh)-1/(2*sh^2)*sum((xlam-mh).^2)+(lam-1)*sum(log(x)) -...
%             m*log(sd)-1/(2*sd^2)*sum((ylam-md).^2)+(lam-1)*sum(log(y))

 [transx transy lam]=boxcoxleo(x,y);
 mh=mean(transx); xlam=transx;  
 md=mean(transy); ylam=transy;  
 sh=sqrt(1./(length(transx))*sum((transx-mean(transx)).^2));
 sd=sqrt(1./(length(transy))*sum((transy-mean(transy)).^2));


  
 I(1,1)=n/sh^2;  
 I(2,2)=-(n/sh^2-3/sh^4*sum((xlam-mh).^2)); 
 I(3,3)=m/sd^2; 
 I(4,4)=-(m/sd^2-3/sd^4*sum((ylam-md).^2));
 
 


 S= I\eye(4,4); %that's better.

 out=S;
end
 

 

 
	