function [bhat Hcox Fcox Scox KMdistcox]=Hcnscox(deaths,H0,knots,kgon)

%Interior function for the HCNS routine.
%Not of primary interest for the user.

y=H0;x=deaths;
t=knots;

     X=zeros(length(x),(length(t)-1)); %preallocate
     for i=1:(length(t)-1)
           X(:,i)=(x-t(i)).^3.*(x>t(i));
     end
options = optimset('LargeScale', 'off','Display', 'off','MaxFunEvals',18000,'MaxIter',18000);

[A,k,Aeq]=conlsqlin(t,kgon);
[bhat] = lsqlin(X,y,A,(k),Aeq,0,[],[],[],options);

g=bhat;
% The last parameter can be explicitly calculated by:
%g(6)=(g(1).*(t(1)-t(5))+g(2).*(t(2)-t(5))+g(3).*(t(3)-t(5))+g(4).*(t(4)-t(5)))./(t(5)-t(6));
g(length(bhat)+1)= (g(1:(end-1))') * (t(1:(end-2))-t(end-1))' / (t(end-1)-t(end));
%-----------------------------------------
%DONE WITH ESTIMATING THE SPLINE
%-----------------------------------------
KMdistcox=sum((HCOX(x,t,g)-y').^2);
bhat=g;
sizex=size(x);if sizex(1)==1;x=x';end
Hcox = @(x) HCOX(x,t,g);
Fcox=@(x)  1-exp(-(Hcox(x)));
Scox=@(x)  1-Fcox(x);
end



function out=HCOX(x,t,g)
%Needs the point at which you wish to evaluate the H(x) ("x")
%Needs the knots "t"
%And the estimated coefs of the spline "g"
sizex=size(x);if sizex(1)==1;x=x';end
Hazx = @(x) sum(bsxfun(@times,g(:),bsxfun(@minus,x',t(:)).^3 .*bsxfun(@gt,x',t(:))),1);
out=Hazx(x);
   if isnan(out)==1;out=Inf;end         
end


